%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fftfilter.m
%
% Test with fft filter
%
% By Magnus Nilsson 2000-12-01
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
f1 = 800;     %First freqz
f2 = 3000;    %Second freqz
fs = 8000;    %Sampling freqz
fc = 2000;    %Cutoff freqz
n = 1:1:1024;
x = sin(2*pi*n*f1/fs)+sin(2*pi*n*f2/fs); 
N = 8;        %Filterlength
Wn = fc/(fs/2);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate filter coefficients using Butterworth filter

[B,A] = butter(N-1,Wn);
freqz(B,1)

s = abs(fft(x));

figure;
subplot(2,1,1); plot(linspace(0,8000,1024),abs(fft(filter(B,1,x))))
axis([0 4000 0 (1.2*max(s))]); 

subplot(2,1,2); plot(linspace(0,8000,1024),s) 
axis([0 4000 0 (1.2*max(s))]); 

C = zeros(1,length(x));
C(1:length(B)) = B;
C = fft(C);
r = fft(x);

D = r.*C;

E = ifft(D);

figure;
subplot(2,1,1);plot(linspace(0,8000,1024),abs(fft(E)));
axis([0 4000 0 (1.2*max(s))]);

Y = fftfilt(B,x);
subplot(2,1,2);plot(linspace(0,8000,1024),abs(fft(Y)));
axis([0 4000 0 (1.2*max(s))]);
