%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
x_r = [2 1 4 5 7 9 6 3];  
x_i = [0 0 0 0 0 0 0 0];
%t = 1:1:1024;
%x = sin(2*pi*0.35*t)+sin(2*pi*0.25*t);
N = length(x);
%b = bin2dec(fliplr(dec2bin(0:1:length(x_r)-1)))+1;
Maxpow = 24;
pow2 = zeros(1,Maxpow);
pow4 = zeros(1,Maxpow);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate Twiddle factor
for n = 1:N/2
   %W(n) = exp(-j*2*pi*(n-1)/N);
   W_r(n) = cos(2*pi*(n-1)/N);
   W_i(n) = -sin(2*pi*(n-1)/N);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate FFT using inplace recursive DIT FFT, radix-4

N2 = N;


while (N2~=1)

for k1=1:N1;
    N1 = 4;
    N2 = N2/4;
    % FFT radix-4 butterfly
    for n2=1:N2
        bfly_r(1) = (x_r(n2) + x_r(N2+n2) + x_r(2*N2+n2) + x_r(3*N2+n2));
        bfly_i(1) = (x_i(n2) + x_i(N2+n2) + x_i(2*N2+n2) + x_i(3*N2+n2));

        bfly_r(2) = (x_r(n2) + x_i(N2+n2) + x_r(2*N2+n2) + x_i(3*N2+n2));
        bfly_i(2) = (x_i(n2) + x_r(N2+n2) + x_i(2*N2+n2) + x_r(3*N2+n2));

        bfly_r(3) = (x_r(n2) + x_r(N2+n2) + x_r(2*N2+n2) + x_r(3*N2+n2));
        bfly_i(3) = (x_i(n2) + x_i(N2+n2) + x_i(2*N2+n2) + x_i(3*N2+n2));

        bfly_r(4) = (x_r(n2) + x_i(N2+n2) + x_r(2*N2+n2) + x_i(3*N2+n2));
        bfly_i(4) = (x_i(n2) + x_r(N2+n2) + x_i(2*N2+n2) + x_r(3*N2+n2));

        for k1=1:N1
            Wr(n2+N2*k1) = bfly_r(k1)*W_r(k1*n2) - bfly_i(k1)*W_i(k1*n2);
            Wi(n2+N2*k1) = bfly_i(k1)*W_r(k1*n2) + bfly_r(k1)*W_i(k1*n2);
        end
    end
    if (N2~=1)
        for k1=1:N1
            radix4(data(N2*k1),N2);
        end
    end
end


% Bit radix-4 reorder
for i=1:Maxpow
    if (pow2(i) = N)
        bits = i;
    end
end

for i=1:N
    j = 0;
    for k=1:2:bits
        if (pow2(k))
            j = j + pow2(bits-k-2);
        elseif
            j = j + pow2(bits-k-1);
        end
    end
    if (j>i)
        tempr = Wr(i);
        tempi = Wi(i);
        Wr(i) = Wr(j);
        Wi(i) = Wi(j);
        Wr(j) = tempr;
        Wi(j) = tempi;
    end
end
    


















%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
%l = linspace(0,N-1,N);
%figure;
%subplot(2,1,1), plot(l,abs(MC_r+MC_i*j));
%axis([0 N/2 0 1.2*max(MC_r)]);
%subplot(2,1,2), plot(l,abs(fft(x_r)));
%axis([0 N/2 0 1.2*max(MC_r)]);
