%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
x_r = [2 1 4 5 ];%7 9 6 3];  
x_i = [0 0 0 0 ];%0 0 0 0];
%t = 1:1:1024;
%x = sin(2*pi*0.35*t)+sin(2*pi*0.25*t);
N = length(x_r);
%b = bin2dec(fliplr(dec2bin(0:1:length(x_r)-1)))+1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate Twiddle factor
for n = 1:N
   W(n) = exp(-j*2*pi*(n-1)/N);
end
   W_r = real(W);
   W_i = imag(W);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate FFT using inplace recursive DIT FFT, radix-4

N2 = 1;
n2 = 1;

        bfly_r(1) = (x_r(n2) + x_r(N2+n2) + x_r(2*N2+n2) + x_r(3*N2+n2));
        bfly_i(1) = (x_i(n2) + x_i(N2+n2) + x_i(2*N2+n2) + x_i(3*N2+n2));

        bfly_r(2) = (x_r(n2) + x_i(N2+n2) + x_r(2*N2+n2) + x_i(3*N2+n2));
        bfly_i(2) = (x_i(n2) + x_r(N2+n2) + x_i(2*N2+n2) + x_r(3*N2+n2));

        bfly_r(3) = (x_r(n2) + x_r(N2+n2) + x_r(2*N2+n2) + x_r(3*N2+n2));
        bfly_i(3) = (x_i(n2) + x_i(N2+n2) + x_i(2*N2+n2) + x_i(3*N2+n2));

        bfly_r(4) = (x_r(n2) + x_i(N2+n2) + x_r(2*N2+n2) + x_i(3*N2+n2));
        bfly_i(4) = (x_i(n2) + x_r(N2+n2) + x_i(2*N2+n2) + x_r(3*N2+n2));

        for k1=1:4
            Wr(n2+N2*k1-1) = bfly_r(k1)*W_r(k1*n2) - bfly_i(k1)*W_i(k1*n2);
            Wi(n2+N2*k1-1) = bfly_i(k1)*W_r(k1*n2) + bfly_r(k1)*W_i(k1*n2);
        end



k = 1;


Block_A_r = x_r(k)*W_r(k);
Block_A_i = x_i(k)*W_i(k);
Block_B_r = x_r(k+1)*W_r(k+1);
Block_B_i = x_i(k+1)*W_i(k+1);
Block_C_r = x_r(k+2)*W_r(k+2);
Block_C_i = x_i(k+2)*W_i(k+2);
Block_D_r = x_r(k+3)*W_r(k+3);
Block_D_i = x_i(k+3)*W_i(k+3);

X_r(k) = Block_A_r +  Block_B_r + Block_C_r + Block_D_r;
X_i(k) = Block_A_i +  Block_B_i + Block_C_i + Block_D_i;

X_r(k+1) = Block_A_r +  Block_B_i - Block_C_r - Block_D_i;
X_i(k+1) = Block_A_i -  Block_B_r - Block_C_i + Block_D_r;

X_r(k+2) = Block_A_r -  Block_B_r + Block_C_r - Block_D_r;
X_i(k+2) = Block_A_i -  Block_B_i + Block_C_i - Block_D_i;

X_r(k+3) = Block_A_r -  Block_B_i - Block_C_r + Block_D_i;
X_i(k+3) = Block_A_i +  Block_B_r - Block_C_i - Block_D_r;

%x(k)+x(k+1)+x(k+2)+x(k+3);


X = X_r+j*X_i;

X
fft(x_r)















%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
%l = linspace(0,N-1,N);
%figure;
%subplot(2,1,1), plot(l,abs(MC_r+MC_i*j));
%axis([0 N/2 0 1.2*max(MC_r)]);
%subplot(2,1,2), plot(l,abs(fft(x_r)));
%axis([0 N/2 0 1.2*max(MC_r)]);
