%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
t = 1:1:4^3;
x_test = sin(2*pi*0.35*t)+sin(2*pi*0.38*t);
Y1 = x_test;
N = length(x_test);
c = 1;
d = 1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate Twiddle factor
for n = 1:N
   W(n) = exp(-j*2*pi*(n-1)/N);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate FFT using inplace DIT FFT, radix-4

for k = 1:N/4

       
    Y2(c)       = W(1)         * (Y1(k) +   Y1(k+N/4) + Y1(k+N/2) +   Y1(k+3*N/4));
    Y2(c+1)     = W((k-1)+1)   * (Y1(k) - j*Y1(k+N/4) - Y1(k+N/2) + j*Y1(k+3*N/4));
    Y2(c+2)     = W(2*(k-1)+1) * (Y1(k) -   Y1(k+N/4) + Y1(k+N/2) -   Y1(k+3*N/4));
    Y2(c+3)     = W(3*(k-1)+1) * (Y1(k) + j*Y1(k+N/4) - Y1(k+N/2) - j*Y1(k+3*N/4));
    c = c+4;
    0
    k-1
    2*(k-1)
    3*(k-1)
    
end

for k = 1:N/4


    Y4(d)       = W(1)         * (Y2(k) +   Y2(k+N/4) + Y2(k+N/2) +   Y2(k+3*N/4));
    Y4(d+1)     = W((k-1)+1)   * (Y2(k) - j*Y2(k+N/4) - Y2(k+N/2) + j*Y2(k+3*N/4));
    Y4(d+2)     = W(2*(k-1)+1) * (Y2(k) -   Y2(k+N/4) + Y2(k+N/2) -   Y2(k+3*N/4));
    Y4(d+3)     = W(3*(k-1)+1) * (Y2(k) + j*Y2(k+N/4) - Y2(k+N/2) - j*Y2(k+3*N/4));
    d = d+4;
end

Y2 = Y4;

for k = 1:N/4
    Y3(k)       = (Y2(k) +   Y2(k+N/4) + Y2(k+N/2) +   Y2(k+3*N/4));
    Y3(k+N/4)   = (Y2(k) - j*Y2(k+N/4) - Y2(k+N/2) + j*Y2(k+3*N/4));
    Y3(k+N/2)   = (Y2(k) -   Y2(k+N/4) + Y2(k+N/2) -   Y2(k+3*N/4));
    Y3(k+3*N/4) = (Y2(k) + j*Y2(k+N/4) - Y2(k+N/2) - j*Y2(k+3*N/4));
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
l = linspace(0,N-1,N);
figure;
subplot(2,1,1);plot(l,abs(Y3));
subplot(2,1,2);plot(l,abs(fft(x_test)));
%axis([0 N/2-1 0 1.2*max(abs(fft(x_test)))]);
