%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4_12.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
t = 1:1:16;
x = sin(2*pi*0.35*t)+sin(2*pi*0.40*t);
N = length(x);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate Twiddle factor
for n = 1:N
   WN(n) = exp(-j*2*pi*(n-1)/N);
end

for n = 1:N
   WN4(n) = exp(-j*2*pi*(n-1)/(N/4));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate FFT using inplace DIT FFT, radix-4

F = zeros(4,(N/4));


%F(l,q) =  x(4*m+l) * W4N(m*q);

for m=1:(N/4)
    for l=1:4
        for q = 1:(N/4)                                                                   
            F(l,q) = F(l,q) + x(4*m+l)*WN4(m*q);
        end
    end
end




















%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
%l = linspace(0,N-1,N);
%figure;
%subplot(2,1,1);plot(l,abs(Y3));
%subplot(2,1,2);plot(l,abs(fft(x_test)));
%axis([0 N/2-1 0 1.2*max(abs(fft(x_test)))]);
