%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
t = 1:1:16;
x = sin(2*pi*0.35*t)+sin(2*pi*0.38*t);
x1 = x;
n = length(x);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

t = log(n)/log(4);

p = 1:1:16;

% Scrambel data
j = 0;
m = 0;
for q = t:-1:1
    s = floor(m/p(q));
    e(q) = m - s*p(q);
    j = p(q)*j + e(q)
    m = s;
end





x = x(b);

for q = 1:t
    L = 4^q;
    r = n/L;
    Lx = L/4;
    for j = 0:Lx-1
        w1 = cos(2*pi*j/L) - i*sin(2*pi*j/L);
        w2 = w1 * w1;
        w3 = w2 * w1;
        for k = 0:r-1
            a = x(k*L+j+1);
            b = w1 * x(k*L+Lx+j+1);
            c = w2 * x(k*L+2*Lx+j+1);
            d = w3 * x(k*L+3*Lx+j+1);
            t0 = a + c;
            t1 = a - c;
            t2 = b + d;
            t3 = b - d;
            x(k*L+j+1) = t0 + t2;
            x(k*L+Lx+j+1) = t1 + i*t3;
            x(k*L+2*Lx+j+1) = t0 - t2;
            x(k*L+3*Lx+j+1) = t1 - i*t3;
        end
    end
end








%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
l = linspace(0,n-1,n);
figure;
subplot(2,1,1);plot(l,abs(x));
subplot(2,1,2);plot(l,abs(fft(x1)));
%axis([0 N/2-1 0 1.2*max(abs(fft(x)))]);
