%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
p = 1:1:16;
x = sin(2*pi*0.35*p)+sin(2*pi*0.38*p);
x1 = x;
n = length(x);
t = log(n)/log(4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Radix-4 Algorithm

f = zeros(n,2*t);
Twiddlefactor = zeros((t*n/4),4);
m = 0;
h =0;

for q = 1:t
    L = 4^q;
    r = n/L;
    Lx = L/4;
    rx = 4*r;
    y = x;
    for j = 0:Lx-1
        for k = 0:r-1
            a = y(j*rx + k + 1);
            b = exp(-i*2*pi*j/L)*y(j*rx + r + k + 1);
            c = exp(-i*2*pi*2*j/L)*y(j*rx + 2*r + k + 1);
            d = exp(-i*2*pi*3*j/L)*y(j*rx + 3*r + k + 1);
            z(m+1) = L;
            t0 = a + c;
            t1 = a - c;
            t2 = b + d;
            t3 = b - d;
            x(j*r + k + 1) = t0 + t2;
            x((j + Lx)*r + k + 1) = t1 - i*t3; 
            x((j + 2*Lx)*r + k + 1) = t0 - t2; 
            x((j + 3*Lx)*r + k + 1) = t1 + i*t3;
            j

            Twiddlefactor(m+1) = 0;
            Twiddlefactor(m+1+(t*n/4)) = j;
            Twiddlefactor(m+1+2*(t*n/4)) = 2*j;
            Twiddlefactor(m+1+3*(t*n/4)) = 3*j;

            f(1+m*4+h*n) = j*rx + k;
            f(1+n+m*4+h*n) = j*r + k;
            f(2+m*4+h*n) = j*rx + r + k;
            f(2+n+m*4+h*n) = (j + Lx)*r + k;
            f(3+m*4+h*n) = j*rx + 2*r + k;
            f(3+n+m*4+h*n) = (j + 2*Lx)*r + k;
            f(4+m*4+h*n) = j*rx + 3*r + k;
            f(4+n+m*4+h*n) = (j + 3*Lx)*r + k;

            m = m+1;
        end        
    end
    h = h+1;
end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
%l = linspace(0,n-1,n);
%figure;
%subplot(2,1,1);plot(l,abs(x));
%subplot(2,1,2);plot(l,abs(fft(x1)));

%n = 1024;
%fs = 8000;
%p = 1:1:1024;
%v = linspace(0,1023,1024);     
%win = chebwin(1024,60);
%signal = 0.3*cos(2*pi*(fs/n)*1*p);
%u = win.*signal';
%hold on;
%plot(v,20*log10(abs(fft(u,1024))),'b')        
%plot(v,20*log10(abs(fft(signal,1024))),'r')  
%xlabel('n');
%ylabel('dB');      
%axis([0 1024/2 -50 50]);
%hold off;

