%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
x_test = [2 1 4 5 ];%7 9 6 3];  
%x_i = [0 0 0 0 ];%0 0 0 0];
t = 1:1:4;
%x_test = sin(2*pi*0.35*t)+sin(2*pi*0.25*t);
N = length(x_test);
%b = bin2dec(fliplr(dec2bin(0:1:length(x_r)-1)))+1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate Twiddle factor
for n = 1:N
   W(n) = exp(-j*2*pi*(n-1)/N);
end
%   W_r = real(W);
%   W_i = imag(W);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate FFT using inplace DIT FFT, radix-4

x = x_test;

q = 1;

for k = 1:N/4

    Y(k)   =  W(0+1)   * (x(k) +   x(k+N/4) + x(k+N/2) +   x(k+3*N/4));
    Y(k+N/4) =  W(q+1) * (x(k) - j*x(k+N/4) - x(k+N/2) + j*x(k+3*N/4));
    Y(k+N/2) = W(2*q+1)   * (x(k) -   x(k+N/4) + x(k+N/2) -   x(k+3*N/4));
    Y(k+3*N/4) = W(3*q+1) * (x(k) - j*x(k+N/4) - x(k+N/2) - j*x(k+3*N/4));
  
    q = q + 1;

end

X = Y;

%for k = 1:4
 %   Y(k)   = (X(k) +   X(k+1) + X(k+2) +   X(k+3));
 %   Y(k+1) = (X(k) - j*X(k+1) - X(k+2) + j*X(k+3));
 %   Y(k+2) = (X(k) -   X(k+1) + X(k+2) -   X(k+3));
 %   Y(k+3) = (X(k) - j*X(k+1) - X(k+2) - j*X(k+3));
%end

    
%C(1) = Y(1);
%C(2) = Y(5);
%C(3) = Y(9);
%C(4) = Y(13);

%C(5) = Y(2);
%C(6) = Y(6);
%C(7) = Y(10);
%C(8) = Y(14);

%C(9) = Y(3);
%C(10) = Y(7);
%C(11) = Y(12);
%C(12) = Y(15);

%C(13) = Y(4);
%C(14) = Y(8);
%C(15) = Y(13);
%C(16) = Y(16);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
l = linspace(0,N-1,N);
figure;
subplot(2,1,1), plot(l,abs(Y));
%axis([0 N/2 0 1.2*max(MC_r)]);
subplot(2,1,2), plot(l,abs(fft(x_test)));
%axis([0 N/2 0 1.2*max(MC_r)]);
