%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
%x_test = [2 1 4 5 ];%7 9 6 3];  
%x_i = [0 0 0 0 ];%0 0 0 0];
t = 1:1:16;
x_test = sin(2*pi*0.35*t)+sin(2*pi*0.25*t);
N = length(x_test);
%b = bin2dec(fliplr(dec2bin(0:1:length(x_r)-1)))+1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate Twiddle factor
for n = 1:N
   W(n) = exp(-j*2*pi*(n-1)/N);
end
%   W_r = real(W);
%   W_i = imag(W);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate FFT using inplace DIT FFT, radix-4

x = x_test;

q = 1;

Y = zeros(1,N);

for k = 1:4:N

    Y(k)   = W(1)         * (x(q) +   x(q+N/4) + x(q+N/2) +   x(q+3*N/4));
    Y(k+1) = W((q-1)+1)   * (x(q) - j*x(q+N/4) - x(q+N/2) + j*x(q+3*N/4));
    Y(k+2) = W(2*(q-1)+1) * (x(q) -   x(q+N/4) + x(q+N/2) -   x(q+3*N/4));
    Y(k+3) = W(3*(q-1)+1) * (x(q) - j*x(q+N/4) - x(q+N/2) - j*x(q+3*N/4));
  
q-1
    q = q + 1;

end

X = Y;

for k = 1:N/4
   Y(k)       = (X(k) +   X(k+N/4) + X(k+N/2) +   X(k+3*N/4));
   Y(k+N/4)   = (X(k) - j*X(k+N/4) - X(k+N/2) + j*X(k+3*N/4));
   Y(k+N/2)   = (X(k) -   X(k+N/4) + X(k+N/2) -   X(k+3*N/4));
   Y(k+3*N/4) = (X(k) - j*X(k+N/4) - X(k+N/2) - j*X(k+3*N/4));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
l = linspace(0,N-1,N);
figure;
plot(l,abs(Y),l,abs(fft(x_test)));

