%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
%x_test = [2 1 4 5 ];%7 9 6 3];  
%x_i = [0 0 0 0 ];%0 0 0 0];
t = 1:1:16;
x_test = sin(2*pi*1/8*t)+sin(2*pi*5/16*t);
N = length(x_test);
%b = bin2dec(fliplr(dec2bin(0:1:length(x_r)-1)))+1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate Twiddle factor
for n = 1:N
   W(n) = exp(-j*2*pi*(n-1)/N);
end
%   W_r = real(W);
%   W_i = imag(W);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate FFT using inplace DIT FFT, radix-4

x = x_test;

q = 1;

Y1 = zeros(1,N);

for k = 1:N/4

    Y1(k)   = W(1)         * (x(q) +   x(q+N/4) + x(q+N/2) +   x(q+3*N/4));
    Y1(k+N/4) = W((q-1)+1)   * (x(q) - j*x(q+N/4) - x(q+N/2) + j*x(q+3*N/4));
    Y1(k+N/2) = W(2*(q-1)+1) * (x(q) -   x(q+N/4) + x(q+N/2) -   x(q+3*N/4));
    Y1(k+3*N/4) = W(3*(q-1)+1) * (x(q) - j*x(q+N/4) - x(q+N/2) - j*x(q+3*N/4));
  

    q = q + 1;

end

X = Y1;

c = 1,

for k = 1:4:N

   Y(c)       = W(1)*(X(k) +   X(k+1) + X(c+2) +   X(k+3));
   Y(c+N/4)   = W((c-1)+1)   * (X(k) - j*X(k+1) - X(k+2) + j*X(k+3));
   Y(c+N/2)   = W(2*(c-1)+1) *(X(k) -   X(k+1) + X(k+2) -   X(k+3));
   Y(c+3*N/4) = W(3*(c-1)+1) *(X(k) - j*X(k+1) - X(k+2) - j*X(k+3));
   c = c+1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
l = linspace(0,N-1,N);
figure;
plot(l,abs(Y),l,abs(fft(x_test)));

%l =1:1024; 
%figure;plot(l,abs(fft(x_test,1024)),l,abs(fft(a,1024)));axis([0 512 0 10]);
