%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% radix4.m
%
% Test with radix 4 algorithm
%
% By Magnus Nilsson 2000-11-30
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
%x_test = [2 1 4 5 ];%7 9 6 3];  
%x_i = [0 0 0 0 ];%0 0 0 0];
t = 1:1:16;
x_test = sin(2*pi*5/8*t)+sin(2*pi*1/8*t);
N = length(x_test);
%b = bin2dec(fliplr(dec2bin(0:1:length(x_r)-1)))+1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate Twiddle factor
for n = 1:N
   W(n) = exp(-j*2*pi*(n-1)/N);
end
%   W_r = real(W);
%   W_i = imag(W);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate FFT using inplace DIT FFT, radix-4

x = x_test;

Y1 = zeros(1,N);

x * W(1);

for k = 1:N/4
    Y1(k)       = W(1)         * (x(k) +   x(k+N/4) + x(k+N/2) +   x(k+3*N/4));
    Y1(k+N/4)   = W((k-1)+1)   * (x(k) - j*x(k+N/4) - x(k+N/2) + j*x(k+3*N/4));
    Y1(k+N/2)   = W(2*(k-1)+1) * (x(k) -   x(k+N/4) + x(k+N/2) -   x(k+3*N/4));
    Y1(k+3*N/4) = W(3*(k-1)+1) * (x(k) + j*x(k+N/4) - x(k+N/2) - j*x(k+3*N/4));
end

X = Y1;
c = 1;

for k = 1:N/4
    Y2(k)       = (X(c) +   X(c+1) + X(c+2) +   X(c+3));
    Y2(k+N/4)   = (X(c) - j*X(c+1) - X(c+2) + j*X(c+3));
    Y2(k+N/2)   = (X(c) -   X(c+1) + X(c+2) -   X(c+3));
    Y2(k+3*N/4) = (X(c) + j*X(c+1) - X(c+2) - j*X(c+3));
    c = c+4;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot results
l = linspace(0,N-1,N);
figure;
subplot(2,1,1);plot(l,abs(Y2));
subplot(2,1,2);plot(l,abs(fft(x_test)));
%axis([0 N/2-1 0 1.2*max(abs(fft(x_test)))]);
