%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%--  
%-------------------------------------------------------------------------
%--           Copyright ERICSSON MICROWAVE SYSTEMS AB 2001              --
%-------------------------------------------------------------------------
%-- 
%-- 
%-- 
%-- The copyright to the source program herein is the
%-- property of Ericsson Microwave Systems AB, Sweden.
%-- The program may be used and/or copied only with the
%-- written permission from Ericsson Microwave Systems
%-- AB or in accordance with the terms and conditions 
%-- stipulated in the agreement/contract under which 
%-- the program have been supplied.
%-- 
%--  
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
%--  
%-- Project     : FFT
%-- Title       : VHDL stimuli
%-- File name   : output.m
%-- Document no : -
%-- Revision    : pa1
%-- Date        : 01-02-05
%-- Prepared    : FX/D Magnus Nilsson
%-- Responsible : FX/DC Anders Wanner
%-- Description : Takes care of output from logical analyse and compare...
%--
%-- ------------------------------------------------------------------------
%-- Revision history: (all revisions included)                            --
%-- ------------------------------------------------------------------------
%-- Rev:   Initials:     Date:    Modification:                           --
%-- ------------------------------------------------------------------------
%-- pa1     emwmsnn     01-02-05   First revision                         --
%-- ------------------------------------------------------------------------
%-- pa2     emwmsnn     01-01-24   Second revision                        --
%-- ------------------------------------------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%------------- Innitialize variables ----------------------%
clear all;
close all;
N=16;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%--------------------- Signal -----------------------------%
t = 1:N;
x1 = sin(2*pi*4/16*t);
x2 = sin(2*pi*4.5/16*t);
x3 = cos(2*pi*4/16*t)+i*sin(2*pi*4/16*t);
x4 = cos(2*pi*4.5/16*t)+i*sin(2*pi*4.5/16*t);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%-For signal X1-%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load X1_ABS_0;
a1_0 = X1_ABS_0(:,2);
b1_0 = X1_ABS_0(:,3);

load X1_ABS_1;
a1_1 = X1_ABS_1(:,2);
b1_1 = X1_ABS_1(:,3);

a1_0 = a1_0(1:16);
b1_0 = b1_0(1:16);     
a1_1 = a1_1(1:16);
b1_1 = b1_1(1:16);

figure;
hold on;
plot(20*log10(abs(a1_0+i*b1_0)+1e-14),'+')
plot(20*log10(a1_1+1e-14),'o--r')
plot(20*log10(abs(fft(x1*2^4))),'*--k')
axis tight;
xlabel('n')
ylabel('db')     
     
A1_0=abs(fft(x1*2^4))'-abs(a1_0+i*b1_0);
Error1_0 = 10*log10(sum(A1_0.^2)/sum((abs(fft(x1*2^4))).^2));

A1_1=abs(fft(x1*2^4))'-a1_1;
Error1_1 = 10*log10(sum(A1_1.^2)/sum((abs(fft(x1*2^4))).^2));

title('Signal X1, FFT FPGA complex, FFT FPGA absolut & FFT Matlab');  
legend(['FPGA complex (Error vs. Matlab in dB) ',num2str(Error1_0)],['FPGA absolut (Error vs. Matlab in dB) ',num2str(Error1_1)],'Matlab')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%-For signal X2-%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load X2_ABS_0;
a2_0 = X2_ABS_0(:,2);
b2_0 = X2_ABS_0(:,3);

load X2_ABS_1;
a2_1 = X2_ABS_1(:,2);
b2_1 = X2_ABS_1(:,3);

a2_0 = a2_0(1:16);
b2_0 = b2_0(1:16);     
a2_1 = a2_1(1:16);
b2_1 = b2_1(1:16);

figure;
hold on;
plot(20*log10(abs(a2_0+i*b2_0)+1e-14),'+')
plot(20*log10(a2_1+1e-14),'o--r')
plot(20*log10(abs(fft(x2*2^4))),'*--k')
axis tight;
xlabel('n')
ylabel('db')     
     
A2_0=abs(fft(x2*2^4))'-abs(a2_0+i*b2_0);
Error2_0 = 10*log10(sum(A2_0.^2)/sum((abs(fft(x2*2^4))).^2));

A2_1=abs(fft(x2*2^4))'-a2_1;
Error2_1 = 10*log10(sum(A2_1.^2)/sum((abs(fft(x2*2^4))).^2));

title('Signal X2, FFT FPGA complex, FFT FPGA absolut & FFT Matlab');  
legend(['FPGA complex (Error vs. Matlab in dB) ',num2str(Error2_0)],['FPGA absolut (Error vs. Matlab in dB) ',num2str(Error2_1)],'Matlab')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%-For signal X3-%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load X3_ABS_0;
a3_0 = X3_ABS_0(:,2);
b3_0 = X3_ABS_0(:,3);

load X3_ABS_1;
a3_1 = X3_ABS_1(:,2);
b3_1 = X3_ABS_1(:,3);

a3_0 = a3_0(1:16);
b3_0 = b3_0(1:16);     
a3_1 = a3_1(1:16);
b3_1 = b3_1(1:16);

figure;
hold on;
plot(20*log10(abs(a3_0+i*b3_0)+1e-14),'+')
plot(20*log10(a3_1+1e-14),'o--r')
plot(20*log10(abs(fft(x3*2^4))),'*--k')
axis tight;
xlabel('n')
ylabel('db')     
     
A3_0=abs(fft(x3*2^4))'-abs(a3_0+i*b3_0);
Error3_0 = 10*log10(sum(A3_0.^2)/sum((abs(fft(x3*2^4))).^2));

A3_1=abs(fft(x3*2^4))'-a3_1;
Error3_1 = 10*log10(sum(A3_1.^2)/sum((abs(fft(x3*2^4))).^2));

title('Signal X3, FFT FPGA complex, FFT FPGA absolut & FFT Matlab');  
legend(['FPGA complex (Error vs. Matlab in dB) ',num2str(Error3_0)],['FPGA absolut (Error vs. Matlab in dB) ',num2str(Error3_1)],'Matlab')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%-For signal X4-%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load X4_ABS_0;
a4_0 = X4_ABS_0(:,2);
b4_0 = X4_ABS_0(:,3);

load X4_ABS_1;
a4_1 = X4_ABS_1(:,2);
b4_1 = X4_ABS_1(:,3);

a4_0 = a4_0(1:16);
b4_0 = b4_0(1:16);     
a4_1 = a4_1(1:16);
b4_1 = b4_1(1:16);

figure;
hold on;
plot(20*log10(abs(a4_0+i*b4_0)+1e-14),'+')
plot(20*log10(a4_1+1e-14),'o--r')
plot(20*log10(abs(fft(x4*2^4))),'*--k')
axis tight;
xlabel('n')
ylabel('db')     
     
A4_0=abs(fft(x4*2^4))'-abs(a4_0+i*b4_0);
Error4_0 = 10*log10(sum(A4_0.^2)/sum((abs(fft(x4*2^4))).^2));

A4_1=abs(fft(x4*2^4))'-a4_1;
Error4_1 = 10*log10(sum(A4_1.^2)/sum((abs(fft(x4*2^4))).^2));

title('Signal X4, FFT FPGA complex, FFT FPGA absolut & FFT Matlab');  
legend(['FPGA complex (Error vs. Matlab in dB) ',num2str(Error4_0)],['FPGA absolut (Error vs. Matlab in dB) ',num2str(Error4_1)],'Matlab')
