%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% test.m
%
% Test with Chebychev window and signal
%
% By Magnus Nilsson 2000-12-13
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
N = 1024;
f1 = 0.7;
f2 = 2.3;
Fs = 8;
var = 0.1;
v = linspace(0,1023,1024);     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Chebychev windowing of the signal
win = chebwin(1024,100);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Program

u = (randn(1,N))*(var/2);
for n = 1:N
   signal(n) = sin(2*pi*f1*n/Fs)+sin(2*pi*f2*n/Fs)+ u(n);
end

s = win.*signal';
hold on;
plot(v,20*log10(abs(fft(s))),'b')        
plot(v,20*log10(abs(fft(signal))),'r')  
xlabel('n');
ylabel('dB');      
axis([0 N/2 -20 70]);
grid on;zoom on;
legend('Windowed signal','Signal');
hold off;

