%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% test.m
%
% Test with Chebychev window and signal
%
% By Magnus Nilsson 2000-12-13
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Innitialize variables.
N = 1024;
f1 = 1.0;
f2 = 2.3;
Fs = 8;
var = 0.1;
v = linspace(0,1023,1024);     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Chebychev windowing of the signal
win = chebwin(1024,100);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Sinal generation
u = (randn(1,N))*(var/2);
n = 1:1024;
signal(n) = sin(2*pi*f1*n/Fs);%;+sin(2*pi*f2*n/Fs)+ u(n);
x = win.*signal';
N = length(x);
t = log(n)/log(4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Radix-4 Algorithm



hold on;
plot(v,20*log10(abs(fft(x))),'b')        
plot(v,20*log10(abs(fft(signal))),'r')  
xlabel('n');
ylabel('dB');      
%axis([0 N/2 -20 70]);
axis tight;
grid on;zoom on;
legend('Windowed signal','Signal');
hold off;

%-------------------------
%function out = trunc(in)
%in = input value
%out = output value
